USE [COWS]
GO
_CreateObject 'SP','web','GetUCaaSEventEmailData'
GO
SET ANSI_NULLS ON
GO
SET QUOTED_IDENTIFIER ON
GO
ALTER PROCEDURE [web].[GetUCaaSEventEmailData] --123857
	@iEventID BIGINT        
AS      
BEGIN      
SET NOCOUNT ON;      

BEGIN TRY      
	OPEN SYMMETRIC KEY FS@K3y     
	DECRYPTION BY CERTIFICATE S3cFS@CustInf0;   
	
	DECLARE @CREAT_DT DATETIME

	SELECT DISTINCT mv.EVENT_ID,    
					CASE WHEN ev.CSG_LVL_ID=0 THEN mv.EVENT_TITLE_TXT ELSE ISNULL(dbo.decryptBinaryData(csd.EVENT_TITLE_TXT),'') END AS EVENT_TITLE_TXT,    
					mv.H1,    
					mv.H6,
					mv.CCD,
					mv.CHARS_ID,    
					mv.SITE_ID,
					mat.UCaaS_ACTY_TYPE_DES,
					mpt.UCaaS_PROD_TYPE_DES,
					mpl.UCaaS_PLAN_TYPE_DES,
					CASE WHEN ev.CSG_LVL_ID=0 THEN mv.CUST_NME ELSE ISNULL(dbo.decryptBinaryData(csd.CUST_NME),'') END AS CUST_NME,    
					mv.CUST_SOW_LOC_TXT,    
					mv.UCaaS_DESGN_DOC,
					mv.SHRT_DES,    
					CASE mv.CNFRC_BRDG_ID    
					WHEN 1 THEN 'Yes'    
					WHEN 0 THEN 'No'    
					ELSE 'No'    
					END AS CNFRC_BRDG_ID,    
					mv.CNFRC_BRDG_NBR,    
					mv.CNFRC_PIN_NBR,
					mv.ONLINE_MEETING_ADR,    
					mv.STRT_TMST,    
					mv.END_TMST,    
					usrc.FULL_NME AS CREAT_BY_USER_ID,    
					usrc.EMAIL_ADR AS CREAT_BY_EMAIL,    
					usrc.USER_ADID AS CREAT_BY_ADID,    
					mv.EXTRA_DRTN_TME_AMT,    
					mv.EVENT_DRTN_IN_MIN_QTY,    
					les.EVENT_STUS_DES AS EVENT_STUS_DES,    
					usrm.FULL_NME AS MODFD_BY_USER_ID,    
					mv.MODFD_DT,    
					mv.CREAT_DT,    
					mv.PUB_EMAIL_CC_TXT,    
					mv.CMPLTD_EMAIL_CC_TXT,    
					lws.WRKFLW_STUS_DES AS WRKFLW_STUS_DES,         
					CASE mv.FAIL_REAS_ID    
					WHEN 0 THEN ' '    
					WHEN NULL THEN ' '    
					ELSE fr.FAIL_REAS_DES    
					END FAIL_REAS_DES,    
					CASE mv.ESCL_REAS_ID    
					WHEN NULL THEN ' '     
					WHEN 0 THEN ' '    
					ELSE er.ESCL_REAS_DES    
					END ESCL_REAS_DES,    
					mv.PRIM_REQ_DT,    
					mv.SCNDY_REQ_DT,    
					CASE mv.REQOR_USER_ID    
					WHEN NULL THEN ' '    
					WHEN 0 THEN ' '    
					ELSE usrr.FULL_NME    
					END REQOR_USER,    
					CASE mv.REQOR_USER_ID    
					WHEN NULL THEN ' '    
					WHEN 0 THEN ' '    
					ELSE usrr.PHN_NBR    
					END REQOR_USER_PHN,
					CASE mv.REQOR_USER_ID    
					WHEN NULL THEN ' '    
					WHEN 0 THEN ' '    
					ELSE usrr.EMAIL_ADR    
					END REQOR_USER_EMAIL,    
					CASE mv.ESCL_CD    
					WHEN 0 THEN 'NOT ESCALATED'    
					WHEN 1 THEN 'ESCALATED'    
					ELSE 'NOT ESCALATED'    
					END AS ESCL_CD,    
					mv.CUST_ACCT_TEAM_PDL_NME,    
					les.EVENT_STUS_DES,    
					lws.WRKFLW_STUS_DES,    
					leso.EVENT_STUS_DES AS OLD_EVENT_STUS_DES,    
					ev.CSG_LVL_ID,
					CASE WHEN ev.CSG_LVL_ID=0 THEN ISNULL(mv.INSTL_SITE_POC_NME,'') ELSE ISNULL(dbo.decryptBinaryData(csd.CUST_CNTCT_NME),'') END AS INSTL_SITE_POC_NME,
					CASE WHEN ev.CSG_LVL_ID=0 THEN ISNULL(mv.INSTL_SITE_POC_PHN_NBR,'') ELSE ISNULL(dbo.decryptBinaryData(csd.CUST_CNTCT_PHN_NBR),'') END AS INSTL_SITE_POC_PHN_NBR,
					CASE WHEN ev.CSG_LVL_ID=0 THEN ISNULL(mv.INSTL_SITE_POC_CELL_PHN_NBR,'') ELSE ISNULL(dbo.decryptBinaryData(csd.CUST_CNTCT_CELL_PHN_NBR),'') END AS INSTL_SITE_POC_CELL_PHN_NBR,
					CASE WHEN ev.CSG_LVL_ID=0 THEN ISNULL(mv.SRVC_ASSRN_POC_NME,'') ELSE ISNULL(dbo.decryptBinaryData(csd.SRVC_ASSRN_POC_NME),'') END AS SRVC_ASSRN_POC_NME,
					CASE WHEN ev.CSG_LVL_ID=0 THEN ISNULL(mv.SRVC_ASSRN_POC_PHN_NBR,'') ELSE ISNULL(dbo.decryptBinaryData(csd.SRVC_ASSRN_POC_PHN_NBR),'') END AS SRVC_ASSRN_POC_PHN_NBR,
					CASE WHEN ev.CSG_LVL_ID=0 THEN ISNULL(mv.SRVC_ASSRN_POC_CELL_PHN_NBR,'') ELSE ISNULL(dbo.decryptBinaryData(csd.SRVC_ASSRN_POC_CELL_PHN_NBR),'') END AS SRVC_ASSRN_POC_CELL_PHN_NBR,
					CASE WHEN ev.CSG_LVL_ID=0 THEN ISNULL(mv.STREET_ADR,'') ELSE ISNULL(dbo.decryptBinaryData(csd.STREET_ADR_1),'') END AS STREET_ADR,
					CASE WHEN ev.CSG_LVL_ID=0 THEN ISNULL(mv.FLR_BLDG_NME,'') ELSE ISNULL(dbo.decryptBinaryData(csd.FLR_ID),'') END AS FLR_BLDG_NME,
					CASE WHEN ev.CSG_LVL_ID=0 THEN ISNULL(mv.CTY_NME,'') ELSE ISNULL(dbo.decryptBinaryData(csd.CTY_NME),'') END AS CTY_NME,
					CASE WHEN ev.CSG_LVL_ID=0 THEN ISNULL(mv.STT_PRVN_NME,'') ELSE ISNULL(dbo.decryptBinaryData(csd.STT_PRVN_NME),'') END AS STT_PRVN_NME,
					CASE WHEN ev.CSG_LVL_ID=0 THEN ISNULL(mv.CTRY_RGN_NME,'') ELSE ISNULL(dbo.decryptBinaryData(csd.CTRY_RGN_NME),'') END AS CTRY_RGN_NME,
					CASE WHEN ev.CSG_LVL_ID=0 THEN ISNULL(mv.ZIP_CD,'') ELSE ISNULL(dbo.decryptBinaryData(csd.ZIP_PSTL_CD),'') END AS ZIP_CD,
					mv.US_INTL_CD,
					scn.SPRINT_CPE_NCR_DES,
					mv.CPE_DSPCH_EMAIL_ADR,
					mv.CPE_DSPCH_CMNT_TXT,
					mv.CMNT_TXT,
					mbn.MDS_BRDG_NEED_TXT,
					mv.DISC_MGMT_CD,
					CASE WHEN mv.FULL_CUST_DISC_CD=0 THEN 'False' WHEN mv.FULL_CUST_DISC_CD=1 THEN 'True' ELSE '' END AS FULL_CUST_DISC_CD,
					mv.FULL_CUST_DISC_REAS_TXT
		FROM		dbo.UCaaS_EVENT mv WITH (NOLOCK)
		INNER JOIN	dbo.[EVENT] ev WITH (NOLOCK) ON ev.EVENT_ID = mv.EVENT_ID
		INNER JOIN	dbo.LK_EVENT_STUS les WITH (NOLOCK) ON les.EVENT_STUS_ID = mv.EVENT_STUS_ID    
		INNER JOIN	dbo.LK_WRKFLW_STUS lws WITH (NOLOCK) ON lws.WRKFLW_STUS_ID = mv.WRKFLW_STUS_ID    
		INNER JOIN	dbo.LK_UCaaS_ACTY_TYPE mat WITH(NOLOCK) ON mat.UCaaS_ACTY_TYPE_ID = mv.UCaaS_ACTY_TYPE_ID    
		INNER JOIN	dbo.LK_UCaaS_PROD_TYPE mpt WITH(NOLOCK) ON mpt.UCaaS_PROD_TYPE_ID = mv.UCaaS_PROD_TYPE_ID
		INNER JOIN	dbo.LK_UCaaS_PLAN_TYPE mpl WITH(NOLOCK) ON mpl.UCaaS_PLAN_TYPE_ID = mv.UCaaS_PLAN_TYPE_ID
		LEFT JOIN   dbo.CUST_SCRD_DATA  csd WITH (NOLOCK) ON csd.SCRD_OBJ_ID=mv.EVENT_ID AND csd.SCRD_OBJ_TYPE_ID=20
		LEFT JOIN  dbo.LK_SPRINT_CPE_NCR scn WITH (NOLOCK) ON scn.SPRINT_CPE_NCR_ID = mv.SPRINT_CPE_NCR_ID
		LEFT JOIN	dbo.LK_EVENT_STUS leso WITH (NOLOCK) ON leso.EVENT_STUS_ID = mv.OLD_EVENT_STUS_ID    
		LEFT JOIN	dbo.LK_FAIL_REAS fr WITH (NOLOCK) ON mv.FAIL_REAS_ID = fr.FAIL_REAS_ID    
		LEFT JOIN	dbo.LK_ESCL_REAS er WITH (NOLOCK) ON er.ESCL_REAS_ID = mv.ESCL_REAS_ID    
		LEFT JOIN	dbo.LK_USER usrc WITH(NOLOCK) ON usrc.[user_id] = mv.CREAT_BY_USER_ID    
		LEFT JOIN	dbo.LK_USER usrm WITH(NOLOCK) ON usrm.[user_id] = mv.MODFD_BY_USER_ID    
		LEFT JOIN	dbo.LK_USER usrr WITH(NOLOCK) ON usrr.[user_id] = mv.REQOR_USER_ID  
		LEFT JOIN	dbo.LK_MDS_BRDG_NEED_REAS mbn  WITH (NOLOCK) ON mbn.MDS_BRDG_NEED_ID = mv.CNFRC_BRDG_ID
		WHERE	mv.EVENT_ID = @iEventID
		
		SELECT 
			[RDSN_NBR],
			[RDSN_EXP_DT],
			[ODIE_DEV_NME],
			[DEV_MODEL_NME],
			[MANF_NME]
		FROM dbo.UCaaS_EVENT_ODIE_DEV od WITH (NOLOCK) INNER JOIN
			 dbo.LK_DEV_MODEL dm WITH (NOLOCK) ON dm.DEV_MODEL_ID = od.DEV_MODEL_ID INNER JOIN
			 dbo.LK_DEV_MANF mf WITH (NOLOCK) ON mf.MANF_ID = od.MANF_ID
		WHERE EVENT_ID = @iEventID
		
		SELECT 
			[ODIE_DEV_NME],
			[H6],
			[CMPLTD_CD]
		FROM dbo.EVENT_DEV_CMPLT dc WITH (NOLOCK)
		WHERE EVENT_ID = @iEventID
		
		SELECT 
			[CPE_ORDR_ID],
			[CPE_ORDR_NBR],
			[DEVICE_ID],
			[ASSOC_H6],
			[MAINT_VNDR_PO],
			[REQSTN_NBR],
			[ODIE_DEV_NME]
		FROM dbo.EVENT_CPE_DEV WITH (NOLOCK)
		WHERE EVENT_ID = @iEventID
		  AND REC_STUS_ID = 1
		
		SELECT 
			dc.[MNS_ORDR_NBR],
			dc.[DEVICE_ID],
			lms.MDS_SRVC_TIER_DES,
			--dbo.[GetCommaSepMNSEntitlements](dc.EVENT_DEV_SRVC_MGMT_ID) as MNS_ENTLMNT_ID_TXT,
			''  as MNS_ENTLMNT_ID_TXT,
			dc.ODIE_DEV_NME
		FROM dbo.EVENT_DEV_SRVC_MGMT dc WITH (NOLOCK) INNER JOIN
			 dbo.LK_MDS_SRVC_TIER lms WITH (NOLOCK) ON dc.MNS_SRVC_TIER_ID = lms.MDS_SRVC_TIER_ID
		WHERE EVENT_ID = @iEventID
		
		SELECT 
			[INC_QTY],
			[DCR_QTY],
			[UCaaS_BILL_ACTY_DES],
			[UCaaS_BIC_TYPE],
			[MRC_NRC_CD]
		FROM dbo.UCaaS_EVENT_BILLING eb WITH (NOLOCK) INNER JOIN
			 dbo.LK_UCaaS_BILL_ACTY ba WITH (NOLOCK) ON ba.UCaaS_BILL_ACTY_ID = eb.UCaaS_BILL_ACTY_ID
		WHERE eb.EVENT_ID = @iEventID
		
	

	SELECT TOP 1	lu.FULL_NME AS MOD_USR_NME,    
					lu.EMAIL_ADR AS MOD_USR_EMAIL,    
					REPLACE(COALESCE(eh.CMNT_TXT, ''),'<br/>','') AS CMNT_TXT    
		FROM		dbo.EVENT_HIST eh WITH (NOLOCK)    
		INNER JOIN	dbo.LK_USER lu WITH (NOLOCK) ON lu.[USER_ID] = eh.CREAT_BY_USER_ID    
		INNER JOIN	dbo.USER_GRP_ROLE ugr WITH (NOLOCK) ON ugr.[USER_ID] = lu.[USER_ID]    
		WHERE		ugr.ROLE_ID IN (22, 23) 
			AND		ugr.REC_STUS_ID = 1 
			AND		eh.EVENT_ID = @iEventID    
			AND		COALESCE(eh.CMNT_TXT, '') <> '' 
			AND		eh.CMNT_TXT NOT LIKE '%-->%'    
		ORDER BY	eh.EVENT_HIST_ID DESC    

	SELECT [dbo].[GetCommaSepAssignUserIDs] (@iEventID) as AssignUsers    

	SELECT [dbo].[GetCommaSepAssignUserEmails] (@iEventID) as AssignEmails    

	SELECT DISTINCT eau.[ASN_TO_USER_ID] AS OLD_ASN_TO_USER_ID,    
					lu.[EMAIL_ADR]    
		FROM		DBO.EVENT_ASN_TO_USER eau WITH (NOLOCK) INNER JOIN    
					DBO.LK_USER lu WITH (NOLOCK) ON lu.[USER_ID] = eau.[ASN_TO_USER_ID]    
		WHERE		eau.[EVENT_ID]=@iEventID    
			AND		eau.REC_STUS_ID=0    
			AND		eau.CREAT_DT = (SELECT TOP 1 CREAT_DT    
									FROM		DBO.EVENT_ASN_TO_USER WITH (NOLOCK)    
									WHERE		[EVENT_ID]=@iEventID    
										AND		REC_STUS_ID=0    
										AND		CREAT_DT <> (SELECT TOP 1 CREAT_DT FROM DBO.EVENT_ASN_TO_USER WITH (NOLOCK)    
																WHERE		[EVENT_ID]=@iEventID    
																	AND		REC_STUS_ID=1    
																ORDER BY	CREAT_DT DESC)    
									GROUP BY	CREAT_DT    
									ORDER BY	CREAT_DT DESC  )

	SELECT TOP 1	lu.FULL_NME AS REV_USR_NME,    
					lu.EMAIL_ADR AS REV_USR_EMAIL,    
					lu.USER_ADID AS REV_USR_ADID,    
					ISNULL(lu.PHN_NBR, '') AS REV_PHN_NBR,
					REPLACE(COALESCE(eh.CMNT_TXT, ''),'<br/>','') AS CMNT_TXT    
		FROM		dbo.EVENT_HIST eh WITH (NOLOCK)    
		INNER JOIN	dbo.LK_USER lu WITH (NOLOCK) ON lu.[USER_ID] = eh.CREAT_BY_USER_ID    
		WHERE		eh.[EVENT_ID]=@iEventID  
			AND		lu.[USER_ID] != 5001		
			AND		eh.[ACTN_ID] IN (5,16)
		ORDER BY	eh.EVENT_HIST_ID DESC  
		
	SELECT [dbo].[getCommaSepRDSNs] (@iEventID, 'UCaaS')   AS RDSN_NBR

	SELECT [dbo].[getCommaSepAssignUserPhoneNumbers] (@iEventID) as AssignUserPhoneNumbers  

	SELECT DISTINCT ed.ODIE_DEV_NME, ed.H5_H6, ed.SITE_ID, ed.DEVICE_ID, ldm.DEV_MODEL_NME, lm.MANF_NME, ed.SERIAL_NBR, ed.THRD_PARTY_CTRCT
	FROM dbo.EVENT_DISCO_DEV ed WITH (NOLOCK) LEFT OUTER JOIN
		 dbo.LK_DEV_MODEL ldm WITH (NOLOCK) ON ldm.DEV_MODEL_ID = ed.DEV_MODEL_ID LEFT OUTER JOIN
		 dbo.LK_DEV_MANF lm WITH (NOLOCK) ON lm.MANF_ID = ed.MANF_ID
	WHERE ed.EVENT_ID = @iEventID
	
	SELECT TOP 1	@CREAT_DT = CREAT_DT    
		FROM		DBO.EVENT_ASN_TO_USER WITH (NOLOCK)    
		WHERE		[EVENT_ID]=@iEventID    
			AND		REC_STUS_ID=0    
			AND		CREAT_DT <> (SELECT TOP 1 CREAT_DT FROM DBO.EVENT_ASN_TO_USER WITH (NOLOCK)    
									WHERE		[EVENT_ID]=@iEventID    
										AND		REC_STUS_ID=1    
									ORDER BY	CREAT_DT DESC)    
		GROUP BY	CREAT_DT    
		ORDER BY	CREAT_DT DESC    

	SELECT DISTINCT eau.[ASN_TO_USER_ID] AS OLD_ASN_TO_USER_ID,    
					lu.[EMAIL_ADR]    
		FROM		DBO.EVENT_ASN_TO_USER eau WITH (NOLOCK) INNER JOIN    
					DBO.LK_USER lu WITH (NOLOCK) ON lu.[USER_ID] = eau.[ASN_TO_USER_ID]    
		WHERE		eau.[EVENT_ID]=@iEventID    
			AND		eau.REC_STUS_ID=0  
			AND		eau.ASN_TO_USER_ID != 5001
			AND		eau.CREAT_DT = @CREAT_DT    
	  

END TRY      
BEGIN CATCH      
	EXEC [dbo].[insertErrorInfo]   
	   
	DECLARE @ErrMsg			nVarchar(4000),       
			@ErrSeverity	Int            
	
	SELECT	@ErrMsg			=	ERROR_MESSAGE(),            
			@ErrSeverity	=	ERROR_SEVERITY()            
	RAISERROR(@ErrMsg, @ErrSeverity, 1)            
END CATCH      
END  
